#define txPin 8 //пин передатчика
#define swPin 5 //пин включения приемника
#define rxPin 2 //пин приемника
#define Te 320

void setup()
{
pinMode(rxPin, INPUT);
pinMode(txPin, OUTPUT);
pinMode(swPin, OUTPUT);
digitalWrite(swPin, HIGH);

Serial.begin(115200); 
Serial.println("Came started");

// RECEIVING
attachInterrupt(0, grab, CHANGE); 
interrupts();
}

volatile static long lastCode = 1;
volatile unsigned int CodeBit;

void loop() {
// SENDING
SendCame(1959); // указываем в HEX если 24
 delay(1000);
 return;
Serial.println(lastCode);
if (lastCode > 0 && lastCode < 4095)
{
Serial.println(lastCode & 0xfff);
lastCode = 0;
} 
else if (lastCode > 0 && lastCode > 4095)
{ 
Serial.println(lastCode & 0xffffff); 
lastCode = 0; 
}
}

// SENDING

void SendCame(long Code) {
for (int j = 0; j < 10; j++) { // для обучения необходимо отправлять 100 раз
// время стартового импульса 
digitalWrite(txPin, HIGH);
delayMicroseconds(320);
digitalWrite(txPin, LOW);
if (Code < 4095) {CodeBit=12;} else {CodeBit=24;}
for (int i = CodeBit; i > 0; i--) {
byte b = bitRead(Code, i - 1); // побитово перебираем и посылаем код
if (b) {
digitalWrite(txPin, LOW); // 1
delayMicroseconds(640);
digitalWrite(txPin, HIGH);
delayMicroseconds(320);
}
else {
digitalWrite(txPin, LOW); // 0
delayMicroseconds(320);
digitalWrite(txPin, HIGH);
delayMicroseconds(640);
}
}
digitalWrite(txPin, LOW);
delayMicroseconds(11520);
}
}



// RECEIVING

#define MAX_DELTA 200
// длительность импульсов может плавать в зависимости от заряда батареии - макс допуск 200 мкс
boolean CheckValue(unsigned int base, unsigned int value)
{
return ((value == base) || ((value > base) && ((value - base) < MAX_DELTA)) || ((value < base) && ((base - value) < MAX_DELTA)));
}
volatile unsigned long prevtime;
volatile unsigned int lolen, hilen, state;
volatile static byte cameCounter = 0; // count of bits stored
volatile static long cameCode = 0; // code itself

void grab() {
state = digitalRead(rxPin);
if (state == HIGH)
lolen = micros() - prevtime;
else
hilen = micros() - prevtime;
prevtime = micros();

if (state == LOW)
{
// последовательность закончилась
if (CheckValue(320, hilen) && CheckValue(640, lolen)) // valid 1
{
cameCode = (cameCode << 1) | 1;
cameCounter++;
}
else if (CheckValue(640, hilen) && CheckValue(320, lolen)) // valid 0
{
cameCode = (cameCode << 1) | 0;
cameCounter++;
}
else cameCounter = 0;
} else 
if (lolen > 1000 &&
(cameCounter == 24) &&
((cameCode & 0xffffff) != 0xffffff))
{
lastCode = cameCode & 0xffffff;
cameCounter = 0;
cameCode = 0;

} else if
(lolen > 1000 &&
(cameCounter == 12) &&
((cameCode & 0xfff) != 0xfff))
{
lastCode = cameCode & 0xfff;
cameCounter = 0;
cameCode = 0;
}
}  
  
